#-----------------pyproject.toml configuration----------------
[build-system]
requires = ["setuptools >= 61.0"]
build-backend = "setuptools.build_meta"

[project]
name = "{{ cookiecutter.project_slug }}"
version = "0.0.1"
description = "{{ cookiecutter.project_short_description }}"
authors = [
    {name = "{{ cookiecutter.author_name }}", email = "{{ cookiecutter.author_email }}"},
]
license = {text = "MIT"}
readme = "README.md"
classifiers = [
    "Development Status :: 3 - Alpha",
    "Intended Audience :: Developers",
    "Operating System :: OS Independent",
    "Programming Language :: Python",
    "Programming Language :: Python :: 3.12",
    "Topic :: Software Development :: Libraries :: Python Modules",
    "Typing :: Typed",
]

requires-python = ">=3.12"

dynamic = ["dependencies", "optional-dependencies"]
[tool.setuptools.dynamic]
dependencies = {file = ["requirements.txt"]}
optional-dependencies = {dev = { file = ["requirements-dev.txt"] }}

[project.urls]
Homepage = "https://example.com/{{ cookiecutter.project_slug }}"

[project.scripts]
{{ cookiecutter.package_name }} = "{{ cookiecutter.package_name }}.cli:cli"



#--------------mypy configuration----------------
[tool.mypy]
# Global options can be specified here
disallow_untyped_defs = true
ignore_missing_imports = true


#-----------------pytest configuration----------------
[tool.pytest.ini_options]
filterwarnings = "ignore::DeprecationWarning:dateutil.*"

log_cli = false
log_cli_level = "DEBUG"
log_cli_format = "%(asctime)s [%(levelname)s] %(message)s (%(filename)s:%(lineno)s)"
log_cli_date_format = "%H:%M:%S"

#-----------------coverage configuration----------------
[tool.coverage.run]
omit = [
    "tests/*",
]

#------------------pylint configuration----------------
[tool.pylint.messages_control]
disable = [
    "missing-module-docstring",
    "missing-class-docstring",
    "missing-function-docstring",
    "invalid-name",
    "logging-fstring-interpolation",
    "unused-argument",
    "import-outside-toplevel",
    "broad-except",
    "line-too-long",
]
[tool.pylint.typecheck]
ignored-modules = ["orjson"]
